// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GSTREAMERMM_TAGSETTER_H
#define _GSTREAMERMM_TAGSETTER_H


#include <glibmm.h>

// -*- Mode: C++; indent-tabs-mode: nil; c-basic-offset: 2 -*-

/* gstreamermm - a C++ wrapper for gstreamer
 *
 * Copyright 2008 The gstreamermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gst/gsttagsetter.h>
#include <glibmm/interface.h>
#include <gstreamermm/enums.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GstTagSetter GstTagSetter;
typedef struct _GstTagSetterClass GstTagSetterClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gst
{ class TagSetter_Class; } // namespace Gst
namespace Gst
{

class TagList;

/** Gst::TagSetter — Gst::Element interface that allows setting and retrieval
 * of media metadata.
 *
 * Elements that support changing a stream's metadata will implement this
 * interface. Examples of such elements are 'vorbisenc', 'theoraenc' and
 * 'id3v2mux'.
 *
 * If you just want to retrieve metadata in your application then all you need
 * to do is watch for tag messages on your pipeline's bus. This interface is
 * only for setting metadata, not for extracting it. To set tags from the
 * application, find tagsetter elements and set tags using e.g. merge_tags() or
 * add_tags(). The application should do that before the element goes to
 * Gst::STATE_PAUSED.
 *
 * Elements implementing the Gst::TagSetter interface often have to merge any
 * tags received from upstream and the tags set by the application via the
 * interface. This can be done like this:
 *
 * TODO: Add code example from C API docs
 */

class TagSetter : public Glib::Interface
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef TagSetter CppObjectType;
  typedef TagSetter_Class CppClassType;
  typedef GstTagSetter BaseObjectType;
  typedef GstTagSetterIFace BaseClassType;

private:
  friend class TagSetter_Class;
  static CppClassType tagsetter_class_;

  // noncopyable
  TagSetter(const TagSetter&);
  TagSetter& operator=(const TagSetter&);

protected:
  TagSetter(); // you must derive from this class

  /** Called by constructors of derived classes. Provide the result of 
   * the Class init() function to ensure that it is properly 
   * initialized.
   * 
   * @param interface_class The Class object for the derived type.
   */
  explicit TagSetter(const Glib::Interface_Class& interface_class);

public:
  // This is public so that C++ wrapper instances can be
  // created for C instances of unwrapped types.
  // For instance, if an unexpected C type implements the C interface. 
  explicit TagSetter(GstTagSetter* castitem);

protected:
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~TagSetter();

  static void add_interface(GType gtype_implementer);

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GstTagSetter*       gobj()       { return reinterpret_cast<GstTagSetter*>(gobject_); }

  ///Provides access to the underlying C GObject.  
  const GstTagSetter* gobj() const { return reinterpret_cast<GstTagSetter*>(gobject_); }

private:


public:
  //TODO: _WRAP_METHOD(void merge_tags(const Glib::RefPtr<const TagList>& list, TagMergeMode), gst_tag_setter_merge_tags)
  //TODO: Wrap rest of GstTagStetter methods


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} // namespace Gst


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gst::TagSetter
   */
  Glib::RefPtr<Gst::TagSetter> wrap(GstTagSetter* object, bool take_copy = false);

} // namespace Glib


#endif /* _GSTREAMERMM_TAGSETTER_H */

